#ifndef BMP
#define BMP

#include "img.h"

#define BMP_SIGNATURE 0x4D42
#define BMP_BITS_PER_PIXEL 24
#define BMP_PADDING_MULTIPLE 4
#define BI_SIZE 40
#define BI_PLANES 1

#pragma pack(push, 1)
#include <stdint.h>

struct bmp_header {
    uint16_t bfType;
    uint32_t bfileSize;
    uint32_t bfReserved;
    uint32_t bfOffBits;
    uint32_t biSize;
    uint32_t biWidth;
    uint32_t biHeight;
    uint16_t biPlanes;
    uint16_t biBitCount;
    uint32_t biCompression;
    uint32_t biSizeImage;
    uint32_t biXPelsPerMeter;
    uint32_t biYPelsPerMeter;
    uint32_t biClrUsed;
    uint32_t biClrImportant;
};
#pragma pack(pop)

enum read_status {
    READ_OK = 0,
    READ_INVALID_SIGNATURE = 1,
    READ_INVALID_BITS = 2,
    READ_INVALID_HEADER = 3,
    READ_MEMORY_ERROR = 4
};

enum write_status {
    WRITE_OK = 0,
    WRITE_ERROR = 1
};
#endif
