#include <stdio.h>
#include <stdlib.h>

#include "../include/img.h"

struct image create_image(const size_t height, const size_t width) {
    struct image new_img = {0};

    if (height == 0 || width == 0) return new_img;

    new_img.height = height;
    new_img.width = width;
    const size_t row = width * sizeof(struct pixel) + (4 - width * sizeof(struct pixel)) % 4 % 4;
    const size_t data_size = row * height;
    new_img.data = malloc(data_size);

    return new_img;
}

void free_image(struct image *image) {
    if (image && image->data) {
        free(image->data);
        image->data = NULL;
    }
}
